org.apache.xerces.xs

## Interface ItemPSVI

- All Known Subinterfaces:
    AttributePSVI, ElementPSVI

      public interface ItemPSVI

  Represents an abstract PSVI item for an element or an attribute information item.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static short` | `VALIDATION_FULL` Validation status indicating that full schema validation has been performed on the item.
    `static short` | `VALIDATION_NONE` Validation status indicating that schema validation has been performed and the item in question has specifically been skipped.
    `static short` | `VALIDATION_PARTIAL` Validation status indicating that schema validation has been performed on the item in question under the rules of lax validation.
    `static short` | `VALIDITY_INVALID` Validity value indicating that validation has been strictly assessed and the item in question is invalid according to the rules of schema validation.
    `static short` | `VALIDITY_NOTKNOWN` Validity value indicating that validation has either not been performed or that a strict assessment of validity could not be performed.
    `static short` | `VALIDITY_VALID` Validation status indicating that schema validation has been performed and the item in question is valid according to the rules of schema validation.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ItemPSVI` | `constant()` Returns a reference to an immutable instance with the same data that this instance of `ItemPSVI` currently has.
    `java.lang.Object` | `getActualNormalizedValue()` Deprecated. Use getSchemaValue().getActualValue() instead
    `short` | `getActualNormalizedValueType()` Deprecated. Use getSchemaValue().getActualValueType() instead
    `StringList` | `getErrorCodes()` `[schema error code]`: a list of error codes generated from the validation attempt or an empty `StringList` if no errors occurred during the validation attempt.
    `StringList` | `getErrorMessages()` A list of error messages generated from the validation attempt or an empty `StringList` if no errors occurred during the validation attempt.
    `boolean` | `getIsSchemaSpecified()` `[schema specified]`: if true, the value was specified in the schema.
    `ShortList` | `getItemValueTypes()` Deprecated. Use getSchemaValue().getListValueTypes() instead
    `XSSimpleTypeDefinition` | `getMemberTypeDefinition()` `[member type definition]`: if and only if that type definition is a simple type definition with {variety} union, or a complex type definition whose {content type} is a simple type definition with {variety} union, then an item isomorphic to that member of the union's {member type definitions} which actually validated the schema item's normalized value.
    `java.lang.String` | `getSchemaDefault()` `[schema default]`: the canonical lexical representation of the declaration's {value constraint} value.
    `java.lang.String` | `getSchemaNormalizedValue()` Deprecated. Use getSchemaValue().getNormalizedValue() instead
    `XSValue` | `getSchemaValue()` If this item has a simple type definition or a complex type with simple content, then return the value with respect to the simple type.
    `XSTypeDefinition` | `getTypeDefinition()` `[type definition]`: an item isomorphic to the type definition used to validate the schema item.
    `short` | `getValidationAttempted()` `[validation attempted]`: determines the extent to which the schema item has been validated.
    `java.lang.String` | `getValidationContext()` The nearest ancestor element information item with a `[schema information]` property (or this element item itself if it has such a property).
    `short` | `getValidity()` `[validity]`: determines the validity of the schema item with respect to the validation being attempted.
    `boolean` | `isConstant()` Returns `true` if this specific instance of `ItemPSVI` is immutable, otherwise `false`.

- - ### Field Detail

    - #### VALIDITY_NOTKNOWN

          static final short VALIDITY_NOTKNOWN

      Validity value indicating that validation has either not been performed or that a strict assessment of validity could not be performed.
      See Also:
        Constant Field Values

    - #### VALIDITY_INVALID

          static final short VALIDITY_INVALID

      Validity value indicating that validation has been strictly assessed and the item in question is invalid according to the rules of schema validation.
      See Also:
        Constant Field Values

    - #### VALIDITY_VALID

          static final short VALIDITY_VALID

      Validation status indicating that schema validation has been performed and the item in question is valid according to the rules of schema validation.
      See Also:
        Constant Field Values

    - #### VALIDATION_NONE

          static final short VALIDATION_NONE

      Validation status indicating that schema validation has been performed and the item in question has specifically been skipped.
      See Also:
        Constant Field Values

    - #### VALIDATION_PARTIAL

          static final short VALIDATION_PARTIAL

      Validation status indicating that schema validation has been performed on the item in question under the rules of lax validation.
      See Also:
        Constant Field Values

    - #### VALIDATION_FULL

          static final short VALIDATION_FULL

      Validation status indicating that full schema validation has been performed on the item.
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### constant

          ItemPSVI constant()

      Returns a reference to an immutable instance with the same data that this instance of `ItemPSVI` currently has.

    - #### isConstant

          boolean isConstant()

      Returns `true` if this specific instance of `ItemPSVI` is immutable, otherwise `false`.

    - #### getValidationContext

          java.lang.String getValidationContext()

      The nearest ancestor element information item with a `[schema information]` property (or this element item itself if it has such a property). For more information refer to element validation context and attribute validation context .

    - #### getValidity

          short getValidity()

      `[validity]`: determines the validity of the schema item with respect to the validation being attempted. The value will be one of the constants: `VALIDITY_NOTKNOWN`, `VALIDITY_INVALID` or `VALIDITY_VALID`.

    - #### getValidationAttempted

          short getValidationAttempted()

      `[validation attempted]`: determines the extent to which the schema item has been validated. The value will be one of the constants: `VALIDATION_NONE`, `VALIDATION_PARTIAL` or `VALIDATION_FULL`.

    - #### getErrorCodes

          StringList getErrorCodes()

      `[schema error code]`: a list of error codes generated from the validation attempt or an empty `StringList` if no errors occurred during the validation attempt.

    - #### getErrorMessages

          StringList getErrorMessages()

      A list of error messages generated from the validation attempt or an empty `StringList` if no errors occurred during the validation attempt. The indices of error messages in this list are aligned with those in the `[schema error code]` list.

    - #### getSchemaNormalizedValue

          java.lang.String getSchemaNormalizedValue()

      Deprecated. Use getSchemaValue().getNormalizedValue() instead
      `[schema normalized value]`: the normalized value of this item after validation.

    - #### getActualNormalizedValue

          java.lang.Object getActualNormalizedValue()
                                                    throws XSException

      Deprecated. Use getSchemaValue().getActualValue() instead
      `[schema normalized value]`: Binding specific actual value or `null` if the value is in error.
      Throws:
        `XSException` - NOT_SUPPORTED_ERR: Raised if the implementation does not support this method.

    - #### getActualNormalizedValueType

          short getActualNormalizedValueType()
                                             throws XSException

      Deprecated. Use getSchemaValue().getActualValueType() instead
      The actual value built-in datatype, e.g. `STRING_DT, SHORT_DT`. If the type definition of this value is a list type definition, this method returns `LIST_DT`. If the type definition of this value is a list type definition whose item type is a union type definition, this method returns `LISTOFUNION_DT`. To query the actual value of the list or list of union type definitions use `itemValueTypes`. If the `actualNormalizedValue` is `null`, this method returns `UNAVAILABLE_DT`.
      Throws:
        `XSException` - NOT_SUPPORTED_ERR: Raised if the implementation does not support this method.

    - #### getItemValueTypes

          ShortList getItemValueTypes()
                                      throws XSException

      Deprecated. Use getSchemaValue().getListValueTypes() instead
      In the case the actual value represents a list, i.e. the `actualNormalizedValueType` is `LIST_DT`, the returned array consists of one type kind which represents the itemType . For example:

           <simpleType name="listtype"> <list
           itemType="positiveInteger"/> </simpleType> <element
           name="list" type="listtype"/> ... <list>1 2 3</list>

      The `schemaNormalizedValue` value is "1 2 3", the `actualNormalizedValueType` value is `LIST_DT`, and the `itemValueTypes` is an array of size 1 with the value `POSITIVEINTEGER_DT`.
      If the actual value represents a list type definition whose item type is a union type definition, i.e. `LISTOFUNION_DT`, for each actual value in the list the array contains the corresponding memberType kind. For example:

           <simpleType
           name='union_type' memberTypes="integer string"/> <simpleType
           name='listOfUnion'> <list itemType='union_type'/>
           </simpleType> <element name="list" type="listOfUnion"/>
           ... <list>1 2 foo</list>

      The `schemaNormalizedValue` value is "1 2 foo", the `actualNormalizedValueType` is `LISTOFUNION_DT` , and the `itemValueTypes` is an array of size 3 with the following values: `INTEGER_DT, INTEGER_DT, STRING_DT`.
      Throws:
        `XSException` - NOT_SUPPORTED_ERR: Raised if the implementation does not support this method.

    - #### getSchemaValue

          XSValue getSchemaValue()

      If this item has a simple type definition or a complex type with simple content, then return the value with respect to the simple type. If this item doesn't have a simple-typed value, the behavior of this method is not specified.

    - #### getTypeDefinition

          XSTypeDefinition getTypeDefinition()

      `[type definition]`: an item isomorphic to the type definition used to validate the schema item.

    - #### getMemberTypeDefinition

          XSSimpleTypeDefinition getMemberTypeDefinition()

      `[member type definition]`: if and only if that type definition is a simple type definition with {variety} union, or a complex type definition whose {content type} is a simple type definition with {variety} union, then an item isomorphic to that member of the union's {member type definitions} which actually validated the schema item's normalized value.

    - #### getSchemaDefault

          java.lang.String getSchemaDefault()

      `[schema default]`: the canonical lexical representation of the declaration's {value constraint} value. For more information refer to element schema default and attribute schema default.

    - #### getIsSchemaSpecified

          boolean getIsSchemaSpecified()

      `[schema specified]`: if true, the value was specified in the schema. If false, the value comes from the infoset. For more information refer to element specified and attribute specified.

Copyright © 1999-2022 The Apache Software Foundation. All Rights Reserved.